# Amiigo

![Logo](icon.jpg)

A GUI for Emuiibo. The Emuiibo sysmodule is required in order to use Amiigo.

<a href="https://github.com/CompSciOrBust/Amiigo/releases"><img src="https://img.shields.io/github/downloads/CompSciOrBust/Amiigo/total?style=for-the-badge" alr = "Downloads " /></a>
<a href="https://discord.gg/ZhRn3nn"><img src="https://img.shields.io/discord/673622282790502402?color=green&label=Discord&logo=discord&style=for-the-badge" alt="Discord Server" /></a>
<a href="https://twitter.com/CompSciOrBust?ref_src=twsrc%5Etfw"><img src="https://img.shields.io/twitter/follow/CompSciOrBust?color=blue&label=follow&logo=twitter&style=for-the-badge" alt="Follow on twitter" /></a>

## Building
To build use the latest version of [LibNX](https://github.com/switchbrew/libnx) and DevkitPro.

## Credits
LibNX and DevkitPro for making the toolchain.

[XorTroll](https://github.com/XorTroll/) for [Emuiibo](https://github.com/XorTroll/emuiibo) and general help.

nlohmann for his [JSON library](https://github.com/nlohmann/json) .

[Kronos2308](https://github.com/Kronos2308) for writing the [code](https://github.com/CompSciOrBust/Amiigo/pull/4) for when Emuiibo isn't running.

N3evin for [AmiiboAPI](https://github.com/N3evin/AmiiboAPI) which is used in Amiigo Maker.

Nichole Mattera for showing me how to load Nintendo's shared font.

Victoria_Borodinova for the [sombrero](https://pixabay.com/illustrations/sombrero-hat-mexico-mexican-4280389/) used in the logo.

[Slluxx](https://github.com/Slluxx) for identifying [a crash](https://github.com/CompSciOrBust/Amiigo/commit/db6942fcdbceb55cd281822fc09f6fe93219c8e5) when no Amiibos are accessible Emuiibo and Amiigo tries to draw their path in the header and then theorizing what caused it to happen.

Everyone in the Team AtlasNX dev chat  for general help in this and other projects.

## Controls

Left or Right on the D-pad will change which menu is currently selected (used for swapping between the Amiibo list and Amiigo Maker).

Up / Down on D-pad to move up and down the list.

* Amiibo List
```
A to select a Amiibo from the list/ enter in folder.

X toggles emulation state.

B backs out of the folder.

Left stick pressed down (like a button) or \-\- delete an Amiibo
```
* Amiibo Maker
```
A create Amiibo

R Download icon from Selected Amiibo

---    Change list categories (amiiboSeries, character, gameSeries) / Change Build location (by categories, by amiibo name on selected folder)

B backs out of the Amiibo series if one is selected in Amiibo Maker.
```

You can also use the touch screen to select an Amiibo by tapping on a item in the list, tapping the emulation status rectangle will toggle the emulation state, and tapping the currently selected Amiibo . Tapping on the right hand list options will change the menu or exit from the app.

## Support
For support please use [Discord](https://discord.io/myrincon) unless you are reporting a bug in which case open a issue here on GitHub.

## Screenshots
<img style="display:inline" src="Screenshots/Screenshot_1.jpg" width="432"/> <img src="Screenshots/Screenshot_2.jpg" width="432"/>
<img src="Screenshots/Screenshot_3.jpg" width="432"/> <img src="Screenshots/Screenshot_4.jpg" width="432"/>
<img src="Screenshots/Screenshot_5.jpg" width="432"/> <img src="Screenshots/Screenshot_6.jpg" width="432"/>
