#include <iostream>
#include <string>
#include <sys/stat.h>
#include <cstring>
#include <fstream>
#include <SDL.h>
#include <SDL2/SDL_ttf.h>
#include <stdlib.h>
#include <switch.h>
#include <vector>
#include <stdio.h>
#include <chrono>
#include "Utils.h"
#include "ConvertBase.hpp"
#include <SDL_image.h>

using namespace std;

int fsize(string fil) {
 std::streampos fsize = 0;

    std::ifstream myfile (fil, ios::in);  // File is of type const char*

    fsize = myfile.tellg();         // The file pointer is currently at the beginning
    myfile.seekg(0, ios::end);      // Place the file pointer at the end of file

    fsize = myfile.tellg() - fsize;
    myfile.close();

    static_assert(sizeof(fsize) >= sizeof(long long), "Oops.");
    return fsize;
}

bool CheckFileExists(string Path)
{
	struct stat Buffer;   
	return (stat (Path.c_str(), &Buffer) == 0); 
}

string GoUpDir(string Path)
{
	Path = Path.substr(0,Path.find_last_of("/\\"));
	Path = Path.substr(0,Path.find_last_of("/\\")+1);
	printf("%s\n",Path.c_str());
	if (Path.size() < 21) return "sdmc:/emuiibo/amiibo/";
	return Path;
}

/*
* copy function
*/
bool copy_me(string origen, string destino) {
    if(CheckFileExists(origen))
	{
		ifstream source(origen, ios::binary);
		ofstream dest(destino, ios::binary);
		dest << source.rdbuf();
		source.close();
		dest.close();
		return true;
	}else{
		return false;
	}
return 0;
}

//tryng to tranlate the emuiibo id from amiibo id, WIP
void toemu(std::string ID,json& JSID){
    printf("AmiiboID: %s \n",ID.c_str());
    JSID["game_character_id"] = std::stoi( shiftAndDec( ID.substr(0,4) ) );
    JSID["character_variant"] = std::stoi( ConvertBase(ID.substr(4,2),  16, 10) );
    JSID["figure_type"] = std::stoi( ConvertBase(ID.substr(6,2),  16, 10) );
    JSID["model_number"] = std::stoi( ConvertBase(ID.substr(8,4),  16, 10) );
    JSID["series"] = std::stoi( ConvertBase(ID.substr(12,2),  16, 10) );
}

void toamii(std::string& ID, json JSID)
{
    //get and convert the values in json and concatenate to form the ID
	ID = 
    refill(shiftAndHex( std::to_string(JSID["game_character_id"].get<int>()) ),4)+
    refill(ConvertBase( std::to_string(JSID["character_variant"].get<int>()),10,16),2)+
    refill(ConvertBase( std::to_string(JSID["figure_type"].get<int>()),10,16),2)+
    refill(ConvertBase( std::to_string(JSID["model_number"].get<int>()),10,16),4)+
    refill(ConvertBase( std::to_string(JSID["series"].get<int>()),10,16),2)+
    "02";
    printf("AmiiboID: %s -\n",ID.c_str());
}

void rezize_PNG (string file_name, int limit) {
    SDL_Surface* pSurface = IMG_Load(file_name.c_str());
    //const int limit = limit;//512;
    int width = pSurface->w;
    int height = pSurface->h;

    if ((width > limit) || (height > limit)) {
        SDL_Rect sourceDimensions;
        sourceDimensions.x = 0;
        sourceDimensions.y = 0;
        sourceDimensions.w = width;
        sourceDimensions.h = height;

        float scale = (float)limit / (float)width;
        float scaleH = (float)limit / (float)height;

        if (scaleH < scale) {
            scale = scaleH;
        }

        SDL_Rect targetDimensions;
        targetDimensions.x = 0;
        targetDimensions.y = 0;
        targetDimensions.w = (int)(width * scale);
        targetDimensions.h = (int)(height * scale);

        SDL_Surface *pScaleSurface = SDL_CreateRGBSurface(
            pSurface->flags,
            targetDimensions.w,
            targetDimensions.h,
            pSurface->format->BitsPerPixel,
            pSurface->format->Rmask,
            pSurface->format->Gmask,
            pSurface->format->Bmask,
            pSurface->format->Amask);

        if (SDL_BlitScaled(pSurface, NULL, pScaleSurface, &targetDimensions) < 0) {
            printf("Error did not scale surface: %s\n", SDL_GetError());
            SDL_FreeSurface(pScaleSurface);
            pScaleSurface = NULL;
        } else {
            SDL_FreeSurface(pSurface);
            pSurface = pScaleSurface;
            width = pSurface->w;
            height = pSurface->h;
            IMG_SavePNG(pSurface, file_name.c_str());
        }
    }
    SDL_FreeSurface(pSurface);
}
